#define _CRT_SECURE_NO_WARNINGS
#include <string>
#include "testlib.h"

using namespace std;

int read_going(int bound, int step, int start, string command_minus, string command_plus, string s, bool finish_command, InStream& stream) {
	int pos_space = s.find(' ');
	if (pos_space == -1)
		stream.quitf(_pe, "Wrong format line (%s), not found space in line!", s.c_str());
	string command = s.substr(0, pos_space);
	if (command != command_minus && command != command_plus) {
		string message = "Need only " + command_minus + "-moving or " + command_plus + "-moving!";
		stream.quitf(_wa, "Wrong command (%s)! %s", message.c_str(), command.c_str());
	}
	s.erase(0, pos_space + 1);
	int delta = stoi(s); 
	string message = command + ' ' + to_string(delta);
	if (command == command_minus) {
		if (start - delta < 0) {
			stream.quitf(_wa, "Wrong command (%s), moving out of bounds", message.c_str());
		}
		if (finish_command && (start - delta) % step != 0) {
			stream.quitf(_wa, "Wrong command (%s), there isn't reference machine into finish point!", message.c_str());
		}
		if (finish_command)
			stream.readEof();
		return delta;
	}
	if (command == command_plus) {
		if (start + delta > bound) {
			stream.quitf(_wa, "Wrong command (%s), moving out of bounds", message.c_str());
		}
		if (finish_command && (start + delta) % step != 0)
			stream.quitf(_wa, "Wrong command (%s), there isn't reference machine into finish point!", message.c_str());
		if (finish_command)
			stream.readEof();
		return delta;
	}
}

string careful_read_line(InStream& stream) {
	string s = stream.readLine();
	int k = s.find("  ");
	while (k != -1) {
		s.erase(k, 1);
		k = s.find("  ");
	}
	if (s.length() > 0 && s[0] == ' ')
		s.erase(0, 1);
	if (s.length() > 0 && s[s.length() - 1] == ' ')
		s.erase(s.length() - 1, 1);
	return s;
}

int read_answer(int bound_x, int bound_y, int step, int start_x, int start_y, InStream& stream) {
	string s = careful_read_line(stream);

	if (start_x % step == 0 && start_y % step == 0) {
		if (s == "Right here") {
			stream.readEof();
			return 0;
		}
		else
			stream.quitf(_wa, "Not need moving, reference machine right here! But participant moving (command = %s).", s.c_str());
	}
	if (start_x % step == 0) {
		return read_going(bound_y, step, start_y, "North", "South", s, true, stream);
	}
	if (start_y % step == 0) {
		return read_going(bound_x, step, start_x, "West", "East", s, true, stream);
	}
	int dx = read_going(bound_x, step, start_x, "West", "East", s, false, stream);
	s = careful_read_line(stream);
	int dy = read_going(bound_y, step, start_y, "North", "South", s, true, stream);
	return dx + dy;
}


int main(int argc, char* argv[]) {
	registerTestlibCmd(argc, argv);
	int n = inf.readInt();
	int m = inf.readInt();
	int x = inf.readInt();
	int a = inf.readInt();
	int b = inf.readInt();

	// reading jury answer
	int len_way_participant = read_answer(n, m, x, a, b, ouf);
	int len_way_jury = read_answer(n, m, x, a, b, ans);
	if (len_way_participant == len_way_jury) 
		quitf(_ok, "The length way is correct.");
	else if (len_way_participant > len_way_jury)
		quitf(_wa, "Jury's answer (len = %d) is shorter, then participant's answer (len = %d).", len_way_jury, len_way_participant);
	else // len_way_participant < len_way_jury
		quitf(_fail, "Participant has better answer (len = %d), then jury (len = %d).", len_way_participant, len_way_jury);
}